<?php
# ***** BEGIN LICENSE BLOCK *****
# This is Custom Code, a plugin for DotClear. 
# Copyright (c) 2005 k-net. All rights reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

$_menu['Plugins']->addItem(__('Custom Code'),'plugin.php?p='.customCode::pluginDir.'','index.php?pf='.customCode::pluginDir.'/icon.png',
		preg_match('/plugin.php\?p='.customCode::pluginDir.'(&.*)?$/',$_SERVER['REQUEST_URI']),
		$core->auth->check('usage,contentadmin',$core->blog->id));

class customCodeAdmin
{
	public static function autoEditCore_isInstalled() {
		global $core;
		
		$tpl_file = DC_ROOT.'/inc/public/lib.urlhandlers.php';
		
		if (file_exists($tpl_file) && is_writable($tpl_file)) {
			$fcontent = file_get_contents($tpl_file);
			return strpos($fcontent, '/* Added by the customCode plugin installation */$content = customCode::customCodeTransform($content);/* End of the added code */');
		}
		return null;
	}
	
	public static function autoEditCore_install() {
		global $core;
		
		$tpl_file = DC_ROOT.'/inc/public/lib.urlhandlers.php';
		if (file_exists($tpl_file) && is_writable($tpl_file)) {
			$fcontent = file_get_contents($tpl_file);
			
			if (strpos($fcontent, '$content = $core->HTMLfilter($content);')) {
				$fcontent = str_replace(
					'$content = $core->HTMLfilter($content);',
					'$content = $core->HTMLfilter($content);/* Added by the customCode plugin installation */$content = customCode::customCodeTransform($content);/* End of the added code */',
					$fcontent);
				file_put_contents($tpl_file, $fcontent);
				$core->blog->triggerBlog();
				return true;
			}
		}
		return false;
	}
	
	public static function autoEditCore_uninstall() {
		global $core;
		$tpl_file = DC_ROOT.'/inc/public/lib.urlhandlers.php';
		
		if (file_exists($tpl_file) && is_writable($tpl_file)) {
			$fcontent = file_get_contents($tpl_file);
			if (strpos($fcontent, '/* Added by the customCode plugin installation */$content = customCode::customCodeTransform($content);/* End of the added code */')) {
				$fcontent = str_replace(
					'/* Added by the customCode plugin installation */$content = customCode::customCodeTransform($content);/* End of the added code */',
					'',
					$fcontent);
				file_put_contents($tpl_file, $fcontent);
				$core->blog->triggerBlog();
				return true;
			}
		}
		return false;
	}
	
	public static function autoEditTpl_isInstalled() {
		global $core;
		
		$settings = new dcSettings($core, $core->blog->id);
		$settings->setNamespace('customcode');
		$tpl_file = $core->blog->themes_path.'/'.$settings->get('theme').'/post.html';
		
		if (file_exists($tpl_file)) {
			$fcontent = file_get_contents($tpl_file);
			
			return strpos($fcontent, '{{tpl:CustomCodeToolbar textarea="c_content"}}');
		}
	}
	
	public static function autoEditTpl_install() {
		global $core;
		
		$settings = new dcSettings($core, $core->blog->id);
		$settings->setNamespace('customcode');
		$tpl_file = $core->blog->themes_path.'/'.$settings->get('theme').'/post.html';
			
		if (file_exists($tpl_file) && is_writable($tpl_file)) {
			$fcontent = file_get_contents($tpl_file);
			
			if (strpos($fcontent, '<p class="field"><label for="c_content">')) {
				$fcontent = str_replace(
					'<p class="field"><label for="c_content">',
					'{{tpl:CustomCodeToolbar textarea="c_content"}}<p class="field"><label for="c_content">',
					$fcontent);
				file_put_contents($tpl_file, $fcontent);
				return true;
			}
		}
		return false;
	}
	
	public static function autoEditTpl_uninstall() {
		global $core;
		
		$settings = new dcSettings($core, $core->blog->id);
		$settings->setNamespace('customcode');
		$tpl_file = $core->blog->themes_path.'/'.$settings->get('theme').'/post.html';
			
		if (file_exists($tpl_file) && is_writable($tpl_file)) {
			$fcontent = file_get_contents($tpl_file);
			
			if (strpos($fcontent, '{{tpl:CustomCodeToolbar textarea="c_content"}}')) {
				$fcontent = str_replace(
					'{{tpl:CustomCodeToolbar textarea="c_content"}}',
					'',
					$fcontent);
				file_put_contents($tpl_file, $fcontent);
				return true;
			}
		}
		return false;
	}
	
	public static function autoEditTpl_formHelp_isInstalled() {
		global $core;
		
		$settings = new dcSettings($core, $core->blog->id);
		$settings->setNamespace('customcode');
		$tpl_file = $core->blog->themes_path.'/'.$settings->get('theme').'/post.html';
			
		if (file_exists($tpl_file)) {
			$fcontent = file_get_contents($tpl_file);
			
			return preg_match('#\<\?php /\* \<p class\="form-help"\>\{\{tpl\:lang HTML code is displayed as text and web addresses are(\s+)automatically converted\.\}\}\</p\> \*/ \?\>#', $fcontent);
		}
		return false;
	}
	
	public static function autoEditTpl_formHelp_install() {
		global $core;
		
		$settings = new dcSettings($core, $core->blog->id);
		$settings->setNamespace('customcode');
		$tpl_file = $core->blog->themes_path.'/'.$settings->get('theme').'/post.html';
			
		if (file_exists($tpl_file) && is_writable($tpl_file)) {
			$fcontent = file_get_contents($tpl_file);
			
			if (preg_match('#\<p class\="form-help"\>\{\{tpl\:lang HTML code is displayed as text and web addresses are(\s+)automatically converted\.\}\}\</p\>#', $fcontent)) {
				$fcontent = preg_replace(
					'#\<p class\="form-help"\>\{\{tpl\:lang HTML code is displayed as text and web addresses are(\s+)automatically converted\.\}\}\</p\>#',
					'<?php /* <p class="form-help">{{tpl:lang HTML code is displayed as text and web addresses are$1automatically converted.}}</p> */ ?>',
					$fcontent);
				file_put_contents($tpl_file, $fcontent);
				return true;
			}
		}
		return false;
	}
	
	public static function autoEditTpl_formHelp_uninstall() {
		global $core;
		
		$settings = new dcSettings($core, $core->blog->id);
		$settings->setNamespace('customcode');
		$tpl_file = $core->blog->themes_path.'/'.$settings->get('theme').'/post.html';
			
		if (file_exists($tpl_file) && is_writable($tpl_file)) {
			$fcontent = file_get_contents($tpl_file);
			
			if (preg_match('#\<\?php /\* \<p class\="form-help"\>\{\{tpl\:lang HTML code is displayed as text and web addresses are(\s+)automatically converted\.\}\}\</p\> \*/ \?\>#', $fcontent)) {
				$fcontent = preg_replace(
					'#\<\?php /\* \<p class\="form-help"\>\{\{tpl\:lang HTML code is displayed as text and web addresses are(\s+)automatically converted\.\}\}\</p\> \*/ \?\>#',
					'<p class="form-help">{{tpl:lang HTML code is displayed as text and web addresses are$1automatically converted.}}</p>',
					$fcontent);
				file_put_contents($tpl_file, $fcontent);
				return true;
			}
		}
		return false;
	}
}

?>