<?php
# ***** BEGIN LICENSE BLOCK *****
# This is Custom Code, a plugin for DotClear. 
# Copyright (c) 2005 k-net. All rights reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

$this->registerModule(
	/* Name */			__('Custom Code'),
	/* Description*/		__('Parse your comments with BBCode or any other code.'),
	/* Author */			'k-net',
	/* Version */			'1.0.2',
	/* Permissions */		'usage,contentadmin'
);

class customCode {
	
	const pluginDir = 'customCode';//basename(dirname(__FILE__));
	
	public static function getConfig() {
		global $core;
		
		$config = array();
		$settings = new dcSettings($core, $core->blog->id);
		$settings->setNamespace('customcode');
		if ($settings->get('customcode_config') != null) {
			$config = unserialize($settings->get('customcode_config'));
		}
		return  is_array($config) ? $config : array();
	}
	
	public static function setConfig($config) {
		global $core;
		
		if (!empty($config) && is_array($config)) {
			$settings = new dcSettings($core, $core->blog->id);
			$settings->setNamespace('customcode');
			$settings->put('customcode_config',serialize($config),'string');
			$core->blog->triggerBlog();
			return true;
		}
		
		return false;
	}
	
	public static function initWikiComment(&$wiki2xhtml) {
		$wiki2xhtml->setOpts(array(
			'active_auto_urls' => 0
		));
	}
	public static function customCodeTransform($str) {
		global $core;
		
		$config = customCode::getConfig();
		
		if (!empty($config['tags'])) {
			$patterns = array();
			$replacements = array();
			
			foreach ($config['tags'] as $tag) {
				if ($tag['on']) {
					$patterns[] = str_replace('\$1', '(.*?)', str_replace('\$2', '(.*?)', '#'.preg_quote($tag['pa']).'#is'));
					$replacements[] = $tag['re'];
				}
			}
			
			$str = preg_replace($patterns, $replacements, $str);
			
			if ($config['options']['delemptytags']) {
				$str = str_replace(array('<p></p>', '<strong></strong>', '<em></em>', '<ins></ins>', '<del></del>'), '', $str);
			}
		}
		
		return $str;
	}
}

?>