<?php
# ***** BEGIN LICENSE BLOCK *****
# This is Custom Code, a plugin for DotClear. 
# Copyright (c) 2005 k-net. All rights reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

if (!defined('DC_CONTEXT_ADMIN')) { exit; }


$errors = array();
$infos = array();

// If first time, auto-install bbCode tags
$settings = new dcSettings($core, $core->blog->id);
$settings->setNamespace('customcode');
if ($settings->get('customcode_config') == null) { // Let's make the config
	$config = array(
		'options' => array('delemptytags' => true),
		'toolbartpl' => '<p class="field"><label>'.htmlspecialchars(__('Parsing')).'&nbsp;:</label><span style="display: block; overflow: hidden;">%s</span></p>'
	);
	customCode::setConfig($config);
	$_POST['tagset_import_replace'] = true;
	$_POST['tagset_import_serverfile'] = 'bbCode-basic.txt';
} else {
	$config = customCode::getConfig();
}


// Save admin configuration
if (isset($_POST['autoEditTpl_uninstall'])) {
	if (customCodeAdmin::autoEditTpl_uninstall()) {
		$infos[] = __('Template restored successfully');
	} else {
		$errors[] = __('Cannot restore template');
	}
} elseif (isset($_POST['autoEditTpl_install'])) {
	if (customCodeAdmin::autoEditTpl_install()) {
		$infos[] = __('Template adapted successfully');
	} else {
		$errors[] = __('Cannot adapt this template');
	}
} elseif (isset($_POST['autoEditCore_uninstall'])) {
	if (customCodeAdmin::autoEditCore_uninstall()) {
		$infos[] = __('Plugin uninstalled from core successfully');
	} else {
		$errors[] = __('Cannot uninstall plugin from core');
	}
} elseif (isset($_POST['autoEditCore_install']) && !customCodeAdmin::autoEditCore_isInstalled()) {
	if (customCodeAdmin::autoEditCore_install()) {
		$infos[] = __('Plugin installed into core successfully');
	} else {
		$errors[] = __('Cannot install plugin into core');
	}
} elseif (isset($_POST['toolbartpl_content'])) {
	$config['toolbartpl'] = $_POST['toolbartpl_content'];
	
	if (customCode::setConfig($config)) {
		$infos[] = __('Configuration successfully updated');
	} else {
		$errors[] = __('Cannot update configuration');
	}
} elseif (isset($_POST['tags']) && is_array($_POST['tags'])) {
	$config['tags'] = array();
	foreach ($_POST['tags'] as $tag) {
		if (isset($tag['dontdelete'])) {
			$config['tags'][] = array(
				'on' => $tag['on'] == 1,
				'cap' => stripslashes($tag['cap']),
				'pa' => stripslashes($tag['pa']),
				're' => stripslashes($tag['re']),
				'abbr' => stripslashes($tag['abbr']),
				'img' => stripslashes($tag['img']),
				'df' => array('be' => stripslashes($tag['df']['be']), 'in' => stripslashes($tag['df']['in']), 'af' => stripslashes($tag['df']['af']))
			);
		}
	}
	$config['options']['delemptytags'] = isset($_POST['options']['delemptytags']);
	
	if (customCode::setConfig($config)) {
		$infos[] = __('Configuration successfully updated');
	} else {
		$errors[] = __('Cannot update configuration');
	}
} elseif (!empty($_POST['newtag'])) {
	$config['tags'][] = array(
		'on' => true,
		'cap' => stripslashes($_POST['newtag']['cap']),
		'pa' => stripslashes($_POST['newtag']['pa']),
		're' => stripslashes($_POST['newtag']['re']),
		'abbr' => stripslashes($_POST['newtag']['abbr']),
		'img' => stripslashes($_POST['newtag']['img']),
		'df' => array('be' => stripslashes($_POST['newtag']['df']['be']), 'in' => stripslashes($_POST['newtag']['df']['in']), 'af' => stripslashes($_POST['newtag']['df']['af']))
	);
	
	if (customCode::setConfig($config)) {
		$infos[] = __('Configuration successfully updated');
	} else {
		$errors[] = __('Cannot update configuration');
	}
} elseif (isset($_POST['tags_delete']) && $_POST['tags_delete'] != '') {
	if (isset($config['tags'][$_POST['tags_delete']])) {
		unset($config['tags'][$_POST['tags_delete']]);
		$config['tags'] = array_values($config['tags']);
	}
	
	if (customCode::setConfig($config)) {
		$infos[] = __('Configuration successfully updated');
	} else {
		$errors[] = __('Cannot update configuration');
	}
} elseif (isset($_POST['tags_up']) && $_POST['tags_up'] != '' && $_POST['tags_up'] > 0) {
	if (isset($config['tags'][$_POST['tags_up']])) {
		$tmp = $config['tags'][$_POST['tags_up']-1];
		$config['tags'][$_POST['tags_up']-1] = $config['tags'][$_POST['tags_up']];
		$config['tags'][$_POST['tags_up']] = $tmp;
	}
	
	if (customCode::setConfig($config)) {
		$infos[] = __('Configuration successfully updated');
	} else {
		$errors[] = __('Cannot update configuration');
	}
} elseif (isset($_POST['tags_down']) && $_POST['tags_down'] != '' && $_POST['tags_down'] < count($config['tags'])-1) {
	if (isset($config['tags'][$_POST['tags_down']])) {
		$tmp = $config['tags'][$_POST['tags_down']+1];
		$config['tags'][$_POST['tags_down']+1] = $config['tags'][$_POST['tags_down']];
		$config['tags'][$_POST['tags_down']] = $tmp;
	}
	
	if (customCode::setConfig($config)) {
		$infos[] = __('Configuration successfully updated');
	} else {
		$errors[] = __('Cannot update configuration');
	}
} elseif (isset($_POST['tagset_import_replace']) || isset($_POST['tagset_import_add'])) {
	if (!empty($_POST['tagset_import_serverfile'])) {
		if (!is_file(dirname(__FILE__).'/tagsets/'.$_POST['tagset_import_serverfile']) || !($tmp = file_get_contents(dirname(__FILE__).'/tagsets/'.$_POST['tagset_import_serverfile']))) {
			$errors[] = __('Cannot read the file');
		}
	} elseif (!empty($_FILES['tagset_import_remotefile']['tmp_name'])) {
		if (!is_file($_FILES['tagset_import_remotefile']['tmp_name']) || !($tmp = file_get_contents($_FILES['tagset_import_remotefile']['tmp_name']))) {
			$errors[] = __('Cannot read the file you have uploaded');
		}
	} else {
		$errors[] = __('No file specified');
	}
	
	if (isset($tmp)) {
		if ($tagset = unserialize($tmp)) {
			if (isset($_POST['tagset_import_replace'])) {
				$config['tags'] = $tagset;
			} else {
				$config['tags'] = array_merge($config['tags'], $tagset);
			}
			
			if (customCode::setConfig($config)) {
				$infos[] = __('Configuration successfully updated');
			} else {
				$errors[] = __('Cannot update configuration');
			}
		} else {
			$errors[] = __('Bad data type in file');
		}
		unset($tmp);
	}
} elseif (isset($_POST['tagset_export'])) {
	$tagset = serialize($config['tags']);
	header('Content-Type: text/plain');
	header('Content-Disposition: attachment; filename="tagset.txt"');
	header('Content-Length: '.strlen($tagset));
	echo $tagset;
	exit;
} elseif (isset($_POST['autoEditTplFormHelp_install'])) {
	if (customCodeAdmin::autoEditTpl_formHelp_install()) {
		$infos[] = __('Template adapted successfully ("form-help" hidden)');
	} else {
		$errors[] = __('Cannot adapt this template ("form-help" shown)');
	}
} elseif (isset($_POST['autoEditTplFormHelp_uninstall'])) {
	if (customCodeAdmin::autoEditTpl_formHelp_uninstall()) {
		$infos[] = __('Template restored successfully ("form-help" shown)');
	} else {
		$errors[] = __('Cannot restore this template ("form-help" hidden)');
	}
}


?>
<html>
<head>
<title><?php echo __('Custom Code'); ?></title>
  <script type="text/javascript">
  //<![CDATA[
	function tags_delete(tagId) {
		document.getElementById('tags_delete').value = tagId;
		document.getElementById('tags_action').submit();
	}
	function tags_up(tagId) {
		document.getElementById('tags_up').value = tagId;
		document.getElementById('tags_action').submit();
	}
	function tags_down(tagId) {
		document.getElementById('tags_down').value = tagId;
		document.getElementById('tags_action').submit();
	}
  //]]>
  </script>
<?php
$part = empty($_GET['part']) ? 'install' : ($_GET['part'] == 'tags' ? 'tags' : 'install');
echo version_compare(DC_VERSION, '2.0-beta4') < 0 ? dcPage::jsMultiPartPage($part) : dcPage::jsPageTabs($part);
?>
<style type="text/css">
.inlinecode {
	padding: 0 4px;
	border: 1px solid #CCC;
	font-family: 'Courier New', Courier, mono;
	font-size: 12px;
}
</style>
</head>

<body>
<?php
echo '<h2>'.__('Custom Code').'</h2>';

if (!empty($errors)) {
	echo '<div class="error">';
	foreach ($errors as $e) {
		echo $e.'<br />';
	}
	echo '</div>';
}
if (!empty($infos)) {
	echo '<div class="message">';
	foreach ($infos as $i) {
		echo $i.'<br />';
	}
	echo '</div>';
}


echo '<div id="install" title="'.__('Installation').'" class="multi-part">';

echo
'<h3>'.__('Install the plugin into the DotClear core').'</h3>'.
'<form action="'.$p_url.'&amp;part=template" method="post">'.
'<p>'.__('In order to transform the posted comments text, Custom Code needs to edit a file in the DotClear core.').'</p>';

$corefile = DC_ROOT.'/inc/public/lib.urlhandlers.php';

if (customCodeAdmin::autoEditCore_isInstalled() === false) {
	echo
	'<p>'.sprintf(__('This file isn\'t yet edited.'), $corefile).' '.
	__('To modify this file automatically, click on this button').'&nbsp;: <input type="submit" name="autoEditCore_install" value="'.__('Install').'" /></p>'.
	'<p>'.__('If you prefer to make the modification by yourself, follow the instructions bellow').'&nbsp;:</p>'.
	'<fieldset>'.
	'<p>'.sprintf(__('Open the file <ins>%s</ins>.'), $corefile).' '.__('Search the following code').'&nbsp;:</p>'.
	'<pre>$content = $core-&gt;HTMLfilter($content);</pre>'.
	'<p>'.__('Just after, add').'&nbsp;:</p>'.
	'<pre>/* Added by the customCode plugin installation */$content = customCode::customCodeTransform($content);/* End of the added code */</pre>'.
	'<p>'.__('That\'s all !').'</p>'.
	'</fieldset>';
} else {
	echo
	'<p>'.sprintf(__('This file is already edited.'), $corefile).' '.
	__('To restore this file automatically, click on this button').'&nbsp;: <input type="submit" name="autoEditCore_uninstall" value="'.__('Uninstall').'" /></p>'.
	'<p>'.__('If you prefer to make the modification by yourself, follow the instructions bellow').'&nbsp;:</p>'.
	'<fieldset>'.
	'<p>'.sprintf(__('Open the file <ins>%s</ins>.'), $corefile).' '.__('Search the following code').'&nbsp;:</p>'.
	'<pre>/* Added by the customCode plugin installation */$content = customCode::customCodeTransform($content);/* End of the added code */</pre>'.
	'<p>'.__('Delete it.').' '.__('That\'s all !').'</p>'.
	'</fieldset>';
}
echo '<p>'.$core->formNonce().'</p>';
echo
'</form>';


$tplfile_theme = $settings->get('theme');
if ($tplfile_theme != 'default' && !file_exists($core->blog->themes_path.'/'.$tplfile_theme.'/post.html')) {
	$tplfile_theme = 'default';
}
$tplfile = 'themes/'.$tplfile_theme.'/post.html';

echo
'<p>&nbsp;</p>'.
'<h3>'.__('Install the toolbar').'</h3>'.
'<form action="'.$p_url.'&amp;part=install" method="post">'.
'<p>'.__('Custom Code also allows you to adapt the template in order to display the codes list in a toolbar above the comment text field.').'</p>';

if (customCodeAdmin::autoEditTpl_isInstalled($tplfile_theme) === false) {
	echo
	'<p>'.sprintf(__('To insert this toolbar into the template, the file <ins>%s</ins> needs to be edited.'), $tplfile).'</p>'.
	'<p>'.__('To modify this file automatically, click on this button').'&nbsp;: <input type="submit" name="autoEditTpl_install" value="'.__('Adapt').'" /></p>'.
	'<p>'.__('If you prefer to make the modification by yourself, follow the instructions bellow').'&nbsp;:</p>'.
	'<fieldset>'.
	'<p>'.sprintf(__('Open the file <ins>%s</ins>.'), $tplfile).' '.__('Search the following code').'&nbsp;:</p>'.
	'<pre>&lt;p class=&quot;field&quot;&gt;&lt;label for=&quot;c_content&quot;&gt;</pre>'.
	'<p>'.__('Just before, add').'&nbsp;:</p>'.
	'<pre>{{tpl:customCodeToolbar textarea=&quot;c_content&quot;}}</pre>'.
	'<p>'.__('That\'s all !').'</p>'.
	'</fieldset>';
} else {
	echo
	'<p>'.sprintf(__('The template file <ins>%s</ins> seems to be already adapted.'), $tplfile).'</p>'.
	'<p>'.__('To restore this file automatically, click on this button').'&nbsp;: <input type="submit" name="autoEditTpl_uninstall" value="'.__('Restore').'" /></p>'.
	'<p>'.__('If you prefer to make the modification by yourself, follow the instructions bellow').'&nbsp;:</p>'.
	'<fieldset>'.
	'<p>'.sprintf(__('Open the file <ins>%s</ins>.'), $tplfile).' '.__('Search the following code').'&nbsp;:</p>'.
	'<pre>{{tpl:customCodeToolbar textarea=&quot;c_content&quot;}}</pre>'.
	'<p>'.__('Delete it.').' '.__('That\'s all !').'</p>'.
	'</fieldset>';
}
echo '<p>'.$core->formNonce().'</p>';
echo
'</form>';

echo
'<p>&nbsp;</p>'.
'<h3>'.__('Personalize the toolbar').'</h3>'.
'<p>'.__('You can edit the smilies toolbar XHTML code to personalize it.').'</p>'.
'<form action="'.$p_url.'&amp;part=install" method="post">'.
'<fieldset>'.
'<p><textarea name="toolbartpl_content" cols="40" rows="10" style="width: 100%; height: 70px;">'.html::escapeHTML($config['toolbartpl']).'</textarea></p>'.
'<p>'.__('<strong>%s</strong> representes the toolbar buttons location.').'</p>'.
'<p><input type="submit" value="'.__('Save').'" /></p>'.
 '<p>'.$core->formNonce().'</p>'.
'</fieldset>'.
'</form>';


echo
'<p>&nbsp;</p>'.
'<h3>'.__('Hide the "form-help" message from the template').'</h3>'.
'<p>'.__('Under the comment from, this message is initially displayed').' "<em>'.__('HTML code is displayed as text and web addresses are automatically converted.').'</em>"</p>'.
'<form action="'.$p_url.'&amp;part=install" method="post">';
$is_installed = customCodeAdmin::autoEditTpl_formHelp_isInstalled();

if (!$is_installed) {
	echo
	'<p>'.sprintf(__('To hide this message, the file <ins>%s</ins> needs to be edited.'), $tplfile).'</p>'.
	'<p>'.__('To modify this file automatically, click on this button').'&nbsp;: <input type="submit" name="autoEditTplFormHelp_install" value="'.__('Hide').'" /></p>'.
	'<p>'.__('If you prefer to make the modification by yourself, follow the instructions bellow').'&nbsp;:</p>'.
	'<fieldset>'.
	'<p>'.sprintf(__('Open the file <ins>%s</ins>.'), $tplfile).' '.__('Search the following code').'&nbsp;:</p>'.
	'<pre>&lt;p class=&quot;form-help&quot;&gt;{{tpl:lang HTML code is displayed as text and web addresses are
      automatically converted.}}&lt;/p&gt</pre>'.
	'<p>'.__('Replace it by').'&nbsp;:</p>'.
	'<pre>&lt;?php /* &lt;p class=&quot;form-help&quot;&gt;{{tpl:lang HTML code is displayed as text and web addresses are
      automatically converted.}}&lt;/p&gt */ ?&gt;</pre>'.
	'<p>'.__('That\'s all !').'</p>'.
	'</fieldset>';
} else {
	echo
	'<p>'.sprintf(__('To show this message, the file <ins>%s</ins> needs to be edited.'), $tplfile).'</p>'.
	'<p>'.
	__('To modify this file automatically, click on this button').'&nbsp;: <input type="submit" name="autoEditTplFormHelp_uninstall" value="'.__('Show').'" /></p>'.
	'<p>'.__('If you prefer to make the modification by yourself, follow the instructions bellow').'&nbsp;:</p>'.
	'<fieldset>'.
	'<p>'.sprintf(__('Open the file <ins>%s</ins>.'), $tplfile).' '.__('Search the following code').'&nbsp;:</p>'.
	'<pre>&lt;?php /* &lt;p class=&quot;form-help&quot;&gt;{{tpl:lang HTML code is displayed as text and web addresses are
      automatically converted.}}&lt;/p&gt */ ?&gt;</pre>'.
	'<p>'.__('Replace it by').'&nbsp;:</p>'.
	'<pre>&lt;p class=&quot;form-help&quot;&gt;{{tpl:lang HTML code is displayed as text and web addresses are
      automatically converted.}}&lt;/p&gt</pre>'.
	'<p>'.__('That\'s all !').'</p>'.
	'</fieldset>';
}
echo
'<p>'.$core->formNonce().'</p>'.
'</form>';

echo
'</div>';



echo '<div id="tags" title="'.__('Tags-').'" class="multi-part">';


if ($settings->get('wiki_comments')) {
	echo
	'<p style="color:#C00"><strong>'.__('The option "Wiki syntax for comments" is enabled. To avoid any conflict with the plugin, it is recommanded to disable it (in the blog settings)').'</strong></p>'.
	'<p>&nbsp;</p>';
}


echo
'<form id="tags_action" action="'.$p_url.'&amp;part=tags" method="post">'.
'<p><input type="hidden" name="tags_delete" value="" /><input type="hidden" name="tags_up" value="" /><input type="hidden" name="tags_down" value="" /></p>'.
'<p>'.$core->formNonce().'</p>'.
'</form>'.
'<form action="'.$p_url.'&amp;part=tags" method="post">'.
'<h3>'.__('Tags-').'</h3>'.

// Description
'<p>'.__('A tag is a group of parameters which will transform a posted comment text.').' '.
__('For instance, a tag with the <em>Pattern</em> <span class="inlinecode">[b]$1[/b]</span> et with the <em>Replacement</em> <span class="inlinecode">&lt;strong&gt;$1&lt;/strong&gt;</span> will transform the text by making it bold : <span class="inlinecode">[b]text[/b]</span> would become <span class="inlinecode"><strong>text</strong></span>.').' '.
__('The <span class="inlinecode">$1</span> and <span class="inlinecode">$2</span> represents the text inside tags.').'<br />'.
__('Of course, you can use other tags than the BBCode ones.').
'</p>'.

'<p>'.__('You can use two variables : <span class="inlinecode">$1</span> and <span class="inlinecode">$2</span>.').' '.
__('Please note that in <em>Pattern</em>, <span class="inlinecode">$1</span> must be placed before <span class="inlinecode">$2</span>.').'</p>'.

'<p><ins>'.__('If you installed the toolbar').'&nbsp;:</ins><br />'.
__('The tag name will be the text appearing when the mouse is over the button').'&nbsp;; '.
__('the button name will be the button title (if the picture isn\'t filled)').'&nbsp;; '.
__('the picture will be displayed on the button').'&nbsp;; '.
__('the default texts will be the texts added <em>before</em> and <em>after</em> the selected text when you click on the button (if nothing is selected the <em>inside</em> text will be added)').'. '.
__('If you don\'t want a tag to appear on the toolbar, leave the button name and the picture empty.').
'</p>'.
'<p>'.__('To delete a tag, uncheck it and save the configuration.').'</p>'.


'<p>'.__('Here are the current tags').'&nbsp;:</p>'.
'<fieldset>'.
'<table style="width: 100%;">'.
'<tr><th style="width: 1%;">&nbsp;</th><th style="width: 1%;">'.__('Action').'</th><th style="width: 30%;">'.__('Tag name').',<br />'.__('Button name').',<br />'.__('Button picture').'</th><th style="width: 35%;">'.__('Pattern').',<br />'.__('Replacement').'</th><th>'.__('Default text').'&nbsp;:<br />'.__('Before, inside, after').'</th></tr>';

if (empty($config['tags'])) {
	echo '<tr><td colspan="6" style="padding-left:30px;color:#999"><em>'.__('No tag').'</em></td></tr>';
} else {
	$count = count($config['tags']);
	foreach ($config['tags'] as $k => $tag) {
		echo
		'<tr>'.
		'<td style="padding-top:18px"><input type="checkbox" name="tags['.$k.'][dontdelete]" checked="checked" /></td>'.
		
		'<td style="text-align:center">'.($k > 0 ? '<a href="#" onclick="javascript:tags_up('.$k.');return false;" style="border:none;"><img src="index.php?pf=customCode/up.png" alt="↑" width="12" height="6" title="'.__('up').'" /></a>' : '&nbsp;').'<br />'.
		'<select name="tags['.$k.'][on]"><option value="1"'.($tag['on'] ? ' selected="selected"' : '').'>'.__('enabled').'</option><option value="0"'.(!$tag['on'] ? ' selected="selected"' : '').'>'.__('disabled').'</option></select><br />'.
		($k < $count-1 ? '<a href="#" onclick="javascript:tags_down('.$k.');return false;" style="border:none;"><img src="index.php?pf=customCode/down.png" alt="↓" width="12" height="6" title="'.__('down').'" /></a>' : '&nbsp;').'</td>'.
		
		'<td><input type="text" name="tags['.$k.'][cap]" value="'.html::escapeHTML($tag['cap']).'" style="width:50%;" /> '.
		'<input type="text" name="tags['.$k.'][abbr]" value="'.html::escapeHTML($tag['abbr']).'" style="width:40%;" /><br />'.
		'<input type="text" name="tags['.$k.'][img]" value="'.html::escapeHTML($tag['img']).'" style="width:100%;" /></td>'.
		
		'<td><input type="text" name="tags['.$k.'][pa]" value="'.html::escapeHTML($tag['pa']).'" style="width:100%;" /><br />'.
		'<input type="text" name="tags['.$k.'][re]" value="'.html::escapeHTML($tag['re']).'" style="width:100%;" /></td>'.
		
		'<td><input type="text" name="tags['.$k.'][df][be]" value="'.html::escapeHTML($tag['df']['be']).'" style="width:35%;" /> '.
		'<input type="text" name="tags['.$k.'][df][in]" value="'.html::escapeHTML($tag['df']['in']).'" style="width:20%;" /> '.
		'<input type="text" name="tags['.$k.'][df][af]" value="'.html::escapeHTML($tag['df']['af']).'" style="width:35%;" /></td>'.
		
		'</tr>';
	}
}

echo
'</table>'.
'<p><label class="classic"><input type="checkbox" name="options[delemptytags]"'.($config['options']['delemptytags'] ? ' checked="checked"' : '').' /> '.
__('Delete the empty output HTML tags (<em>&lt;p&gt;&lt;/p&gt;</em>, <em>&lt;em&gt;&lt;/em&gt;...</em>)').'</label></p>'.
'<p><input type="submit" value="'.__('Save').'" /></p>'.
'</fieldset>'.
'<p>'.$core->formNonce().'</p>'.
'</form>'.


'<p>&nbsp;</p>'.
'<form action="'.$p_url.'&amp;part=tags" method="post">'.
'<h3>'.__('Add a tag').'</h3>'.
'<fieldset>'.
'<table style="width: 100%;">'.

'<tr><th style="width: 30%;">'.__('Tag name').',<br />'.__('Button name').',<br />'.__('Button picture').'</th><th style="width: 45%;">'.__('Pattern').',<br />'.__('Replacement').'</th><th style="width: 24%;">'.__('Default text').'&nbsp;:<br />'.__('Before, inside, after').'</th></tr>'.

'<tr>'.

'<td><input type="text" name="newtag[cap]" value="" style="width:50%;" /> '.
'<input type="text" name="newtag[abbr]" value="" style="width:40%;" /><br />'.
'<input type="text" name="newtag[img]" value="" style="width:100%;" /></td>'.

'<td><input type="text" name="newtag[pa]" value="" style="width:100%;" /><br />'.
'<input type="text" name="newtag[re]" value="" style="width:100%;" /></td>'.

'<td><input type="text" name="newtag[df][be]" value="" style="width:35%;" /> '.
'<input type="text" name="newtag[df][in]" value="" style="width:20%;" /> '.
'<input type="text" name="newtag[df][af]" value="" style="width:35%;" /></td>'.

'</tr>'.

'</table>'.
'<p><input type="submit" value="'.__('Add').'" /></p>'.
'</fieldset>'.
'<p>'.$core->formNonce().'</p>'.
'</form>';


if (is_dir(dirname(__FILE__).'/tagsets')) {
	$tagset_files = '';
	
	$handle = opendir(dirname(__FILE__).'/tagsets');
	while ($file = readdir($handle)) {
		if (is_file(dirname(__FILE__).'/tagsets/'.$file)) {
			$tagset_files .= '<option value="'.html::escapeHTML($file).'">'.html::escapeHTML($file).'</option>';
		}
	}
}

echo
'<p>&nbsp;</p>'.
'<form action="'.$p_url.'&amp;part=tags" method="post" enctype="multipart/form-data">'.
'<h3>'.__('Import a presaved tag set').'</h3>'.
'<p>'.__('You can auto install a presaved tag set, created by you or one of the default ones (such as BBCode, basic HTML...)').'</p>'.
'<fieldset>'.
'<p><label class="classic">'.__('Select the tag set to install').'&nbsp;: ';
if (!empty($tagset_files)) {
	echo
	'<select name="tagset_import_serverfile"><option value="">&nbsp;</option>'.$tagset_files.'</select> '.__('or').' ';
}
echo
'<input type="file" name="tagset_import_remotefile" /></label></p>'.
'<p><input type="submit" name="tagset_import_replace" value="'.__('Replace').'" /> or <input type="submit" name="tagset_import_add" value="'.__('Add').'" /> '.__('to the current ones').'.</p>'.
'</fieldset>'.
'<p>'.$core->formNonce().'</p>'.
'</form>';


echo
'<p>&nbsp;</p>'.
'<form action="'.$p_url.'&amp;part=tags" method="post">'.
'<h3>'.__('Export the current tags in a new tag set').'</h3>'.
'<p>'.__('You can save the current tags and all their parameters in a file you can import in the future.').'</p>'.
'<fieldset>'.
'<p><input type="submit" name="tagset_export" value="'.__('Download the tag set').'" /></p>'.
'</fieldset>'.
'<p>'.$core->formNonce().'</p>'.
'</form>';


echo
'</div>';

?>
</body>
</html>